package sk.upjs.js;

import java.util.ArrayList;
import java.util.List;

/**
 * Databaza so studentami napevno
 *
 */
public class FixedDatabase {
	private List<Student> students = new ArrayList<Student>();

	public FixedDatabase() {
		students.add(new Student(1, "John", "Doe", 1));
		students.add(new Student(2, "Michael", "Jackson", 1));
		students.add(new Student(3, "Jane", "Greengroces", 2));
		students.add(new Student(4, "Arthur", "Pewtey", 4));
		students.add(new Student(5, "Sidney", "Pollack", 3));
		students.add(new Student(6, "Andrew", "Mordon", 5));
	}
	
	  /**
	   * Vrti zoznam vetkch tudentov v databze. Zoznam
	   * je nemeniten.
	   */
	  public List<Student> listStudents() {
	    return students;
	  }

	  /**
	   * Njde v databze tudenta s danm identifiktorom. Ak
	   * sa tak tudent nenjde, vrti <code>null</code>.
	   */
	  public Student findById(Integer id) {
	    for (Student student : students) {
	      if(student.getId().equals(id)) {
	        return student;
	      }
	    }
	    return null;
	  }

	  /**
	   * Ulo alebo aktualizuje objekt tudenta. Ak m tudent
	   * identifiktor rovn <code>null</code>, znamen
	   * to intanciu, ktor v databze ete nie je. V opanom 
	   * prpade sa existujca intancia s takm ID nahrad
	   * novou intanciou s aktualizovanmi dtami. 
	   * 
	   * @param student
	   */
	  public void saveOrUpdate(Student student) {
	    if(student.getId() == null) {
	      students.add(student);
	      return;
	    }
	    Student dbStudent = findById(student.getId());
	    students.remove(dbStudent);
	    students.add(student);
	  }

	  /**
	   * Odstrni z databzy tudenta s danm identifiktorom.
	   * Intancia v parametri nemus ma vyplnen vetky daje, sta,
	   * ke m vyplnen identifiktor.
	   */ 
	  public void removeStudent(Student student) {
	    Student dbStudent = findById(student.getId());
	    if(dbStudent != null) {
	      students.remove(dbStudent);
	    }
	  }
}
